/**
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package us.levk.remote.drmaa.common.api;

import java.io.Serializable;
import java.util.Map;
import java.util.UUID;

import org.ggf.drmaa.DrmaaException;


/**
 * <p>This interface mimics the JobInfo interface adding the instance id to all methods</p>
 * 
 * @author levk
 *
 */
public interface RemoteJobInfo extends Serializable {

  String getJobId (UUID info) throws DrmaaException;
  Map<?, ?> getResourceUsage (UUID info) throws DrmaaException;
  boolean hasExited (UUID info) throws DrmaaException;
  int getExitStatus (UUID info) throws DrmaaException;
  boolean hasSignaled (UUID info) throws DrmaaException;
  String getTerminatingSignal (UUID info) throws DrmaaException;
  boolean hasCoreDump (UUID info) throws DrmaaException;
  boolean wasAborted (UUID info) throws DrmaaException;
}
